#
# Copyright 2001 by Object Craft P/L, Melbourne, Australia.
#
# LICENCE - see LICENCE file distributed with this software for details.
#
# 
# Test template expansion.
#
# $Id: lookup.py 15353 2010-01-18 09:09:09Z andrewm $

import unittest
import albatross
import template_common

class LookupTestCommon(template_common.TemplateTestCommon):

    template_dir = "lookup"
    lookup_cases = (
        (0,	"Zero"),
        (1,	"One"),
        (2,	"Two"),
        (3,	"Many"),
        (4,	"Many"),
        (-1,	"Many"),
        (20,	"Many")
    )

    def cases_expect(self, template, cases):
        for i, result in cases:
            self.ctx.locals.i = i
            self.html_test(template, result)


class InlineCase(LookupTestCommon):

    def test_enum(self):
        self.cases_expect('inline.html', self.lookup_cases)


class FileTemplateCase(LookupTestCommon):

    def test_enum(self):
        self.cases_expect('lookup.html', self.lookup_cases)

    def test_no_default(self):
        no_default_cases = (
            (0,	"Zero"),
            (1,	"One"),
            (2,	""),
            (20, ""),
        )
        self.cases_expect('no-default.html', no_default_cases)

    def test_no_close(self):
        self.tmpl_exc("no-close.html")


# This differs from the previous class because it generates the html output by
# feeding in a string to the templating code.

class StringTemplateCase(LookupTestCommon):

    template_string = '''
<al-lookup name="xlat">
 <al-item expr="0">Zero</al-item>
 <al-item expr="1">One</al-item>
 <al-item expr="2">Two</al-item>
 Many</al-lookup>
<al-value expr="i" lookup="xlat">
'''
    def test_enum(self):
        for i, result in self.lookup_cases:
            self.ctx.locals.i = i
            self.str_html_test(self.template_string, result)


if __name__ == '__main__':
    unittest.main()


