#
# Copyright 2001 by Object Craft P/L, Melbourne, Australia.
#
# LICENCE - see LICENCE file distributed with this software for details.
#
# 
# Test macros.
#
# $Id: macro.py 15353 2010-01-18 09:09:09Z andrewm $

import unittest
import albatross
import template_common

class MacroCase(template_common.TemplateTestCommon):

    template_dir = "macro"

    def test_macro_0arg(self):
        self.html_test("0arg.html", "content\n")

    def test_macro_0arg_dup(self):
        self.html_test("0arg-dup.html", "content\ncontent\n")

    def test_macro_1arg(self):
        self.html_test("1arg.html", "xxx argument xxx\n")

    def test_macro_2arg(self):
        self.html_test("2arg.html", "xxx first second xxx\n")

    def test_macro_simplearg(self):
        self.html_test("simplearg.html", "xxx aaa bbb xxx\n")

    def test_macro_argexpr(self):
        self.ctx.locals.aaa = 'first'
        self.ctx.locals.bbb = 'second'
        self.html_test("argexpr.html", "xxx first second xxx\n")

    def test_macro_unnamed(self):
        self.html_test("unnamed.html", "xxx unnamed body xxx\n")

    def test_macro_unnamedarg(self):
        self.html_test("unnamedarg.html", "xxx argument")

    def test_macro_nested(self):
        self.html_test("nested.html", "aaa second bbb first ccc second ddd\n")

    def test_macro_default(self):
        self.html_test("default.html", "aaa first bbb\naaa catflap bbb\n")

    def test_macro_defaultnested(self):
        self.html_test("defaultnested.html", "aaa second bbb first ccc second ddd catflap eee\n")

    def test_macro_unclosed(self):
        self.tmpl_exc("unclosed.html")

    def test_macro_unclosedarg(self):
        self.tmpl_exc("unclosedarg.html")

    def test_macro_missingarg(self):
        self.tmpl_exc("missingarg.html")


if __name__ == '__main__':
    unittest.main()
