#
# Copyright 2004 by Object Craft P/L, Melbourne, Australia.
#
# LICENCE - see LICENCE file distributed with this software for details.
#
# 
# Test "require" tag
#
# $Id: require.py 15353 2010-01-18 09:09:09Z andrewm $

import unittest
import albatross
import template_common

class RequireCase(template_common.TemplateTestCommon):
    template_dir = "require"

    def test_require(self):
        self.str_html_test("<al-require>", "")
        self.str_tmpl_exc("<al-require nosuchattribute=\"\">")

    def test_require_version(self):
        fmt = "<al-require version=\"%d\">"
        self.str_html_test(fmt % albatross.template_version, "")
        self.str_html_test(fmt % (albatross.template_version - 1), "")
        self.str_tmpl_exc(fmt % (albatross.template_version + 1))

    def test_require_feature(self):
        self.str_html_test("<al-require feature=\"\">", "")
        self.str_tmpl_exc("<al-require feature=\"nosuchfeature\">")


if __name__ == '__main__':
    unittest.main()
